breed [ birds bird ]
breed [ worms worm ]
worms-own [ energy ]
birds-own [ foraged-worms probability-worm-search reward ]
patches-own [ consumed-energy patch-energy H-init Health ]
globals [ max-annual-total-pred energy-requirement max-patch-health S-init number B-init branch-energy  patches-per-branch factor ]

to setup
ca
set patches-per-branch count patches / (max-branch-density * area-size)
set max-patch-health max-branch-health / patches-per-branch 
ask patches [ set H-init 0.001 ] 
set S-init 100 
set B-init 1000
create-worms B-init ;[ move-to one-of patches set shape "caterpillar" set size 2 set color orange ]
;set number-of-birds area-size * max-annual-total-pred / (365 * max-daily-pred)
set energy-requirement 1 set branch-energy max-density * energy-requirement 
create-birds number-of-birds * 365 * area-size [ move-to one-of patches set shape "hawk" set size 3 set color blue ]
ask birds [ hide-turtle ] ask n-of floor number-of-birds birds [ show-turtle ] 
ask n-of ceiling (S-init * patches-per-branch) patches [ set pcolor green set Health H-init set patch-energy branch-energy / patches-per-branch ]   

end

to go
tick
display-birds
worm-death
worm-reproduce
bird-predate
tree-growth
if ticks mod years = 0 [ create-worms impact [ move-to one-of patches set shape "caterpillar" set size 2 set color orange ] ]
set-current-plot "Biomass Cover (%)"
plot count patches with [ pcolor = green ]

end

to display-birds
ask birds [ hide-turtle ]
ask n-of floor number-of-birds birds [ show-turtle ] 
if (random-float 1 < number-of-birds - floor number-of-birds) [ ask one-of birds [ show-turtle ] ]
end

to worm-death
ask patches [ set consumed-energy 0 ]
foreach shuffle sort worms [ ask ? [ 
move-to one-of patches 
set energy min (list energy-requirement [ patch-energy ] of patch-here) set [ patch-energy ] of patch-here [ patch-energy ] of patch-here - energy ] ]
ask worms with [ energy < energy-requirement ] [ die ] 
set-current-plot "Budworm Population"
plot count worms

end

to worm-reproduce
ask worms [ hatch floor reproduction-rate [ set energy 0 ] ]
ask worms [ if (random-float 1 < (reproduction-rate - floor reproduction-rate)) [ hatch 1 [ set energy 0 ] ] ]
show ticks
if (count worms < B-init) [ create-worms (B-init - count worms) [ move-to one-of patches set shape "caterpillar" set size 2 set color orange ] ]
end


to bird-predate
ask birds [ 
set reward (count worms ^ 2) / (learning-lag ^ 2)
repeat (max-daily-pred) [ ifelse (random-float 1 < reward) [ move-to one-of patches with [ any? worms-here = true ] 
ask one-of worms-here [ die ] ] [ move-to one-of patches ] ]  
]
end

to bird-predate-2
ask birds [ 
repeat (max-daily-pred) [ move-to one-of patches if any? worms-here [ ask one-of worms [ die ] ] ] 
]
end

to tree-growth
ask patches with [ pcolor = green ] [ set consumed-energy branch-energy / patches-per-branch - patch-energy ]
ask patches [ if (random-float max-patch-health > Health) [ set pcolor black ] ]
let g max (list (S-init * patches-per-branch - count patches with [ pcolor = green ]) 0)
ask n-of g patches with [ pcolor = black ] [ set pcolor green ]
ask patches with [ pcolor = green ] [ if (random-float 1 < branch-growth-rate) [ ask one-of other patches [ 
set pcolor green set Health random-float max-patch-health ] ] ]
ask patches with [ pcolor = green ] [ 
set Health max (list H-init (Health + health-recovery-rate * Health * (1 - Health / max-patch-health) - health-reduction * consumed-energy)) ]
ask patches with [ pcolor = green ] [ set patch-energy branch-energy / patches-per-branch ]
ask patches with [ pcolor = black ] [ set patch-energy 0 ]
end

to reset
set reproduction-rate 1.6
set max-density 200
set learning-lag 1800
set max-daily-pred 75
set max-annual-total-pred 28000
set max-branch-health 1
set health-recovery-rate 1
set health-reduction 0.0015 
set branch-growth-rate 0.15 
set max-branch-density 24000
set number-of-birds round (max-annual-total-pred / (365 * max-daily-pred) * 10000) / 10000
end


@#$#@#$#@
GRAPHICS-WINDOW
2
112
322
440
-1
-1
6.2
1
10
1
1
1
0
1
1
1
0
49
0
47
0
0
1
ticks

CC-WINDOW
5
598
1170
693
Command Center
0

BUTTON
4
10
91
73
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
92
10
179
73
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

PLOT
324
10
1158
233
Budworm Population
Time
Total
0.0
10.0
0.0
10.0
true
false
PENS
"default" 1.0 0 -16777216 true

SLIDER
286
473
578
506
learning-lag
learning-lag
0
5000
1800
50
1
NIL
HORIZONTAL

SLIDER
286
511
578
544
max-daily-pred
max-daily-pred
0
750
75
1
1
worms bird-1 d-1
HORIZONTAL

SLIDER
4
473
282
506
reproduction-rate
reproduction-rate
0
2
1.6
0.05
1
y-1
HORIZONTAL

PLOT
324
236
1158
440
Biomass Cover (%)
Time
%
0.0
10.0
0.0
10.0
true
false
PENS
"default" 1.0 0 -16777216 true

SLIDER
184
24
317
57
area-size
area-size
0
10
0.1
0.01
1
acres
HORIZONTAL

SLIDER
4
510
282
543
max-density
max-density
0
300
200
10
1
worms branch-1
HORIZONTAL

SLIDER
285
548
578
581
number-of-birds
number-of-birds
0
5
1.0228
0.1
1
birds acre-1
HORIZONTAL

SLIDER
890
511
1161
544
max-branch-density
max-branch-density
0
50000
24000
1000
1
branches acre-1
HORIZONTAL

SLIDER
582
473
885
506
max-branch-health
max-branch-health
0
10
1
1
1
unit branch-1
HORIZONTAL

SLIDER
889
473
1160
506
branch-growth-rate
branch-growth-rate
0
2
0.15
0.01
1
y-1
HORIZONTAL

SLIDER
582
511
885
544
health-recovery-rate
health-recovery-rate
0
2
1
0.01
1
y-1
HORIZONTAL

SLIDER
582
548
885
581
health-reduction
health-reduction
0
1
0.0015
0.0001
1
units consumed-energy-1
HORIZONTAL

TEXTBOX
890
453
1040
471
Biomass growth:
11
0.0
1

TEXTBOX
11
451
161
469
Budworm growth:
11
0.0
1

TEXTBOX
288
452
438
470
Predation by birds:
11
0.0
1

TEXTBOX
586
453
736
471
Biomass health:
11
0.0
1

TEXTBOX
10
553
160
581
y = year\nd = day
11
0.0
1

BUTTON
122
551
185
584
NIL
reset
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
219
76
321
109
years
years
0
100
5
1
1
NIL
HORIZONTAL

SLIDER
82
76
178
109
impact
impact
0
10000
1900
100
1
NIL
HORIZONTAL

TEXTBOX
13
87
77
105
An event of 
11
0.0
1

TEXTBOX
185
86
217
104
every
11
0.0
1

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

caterpillar
true
0
Polygon -7500403 true true 165 210 165 225 135 255 105 270 90 270 75 255 75 240 90 210 120 195 135 165 165 135 165 105 150 75 150 60 135 60 120 45 120 30 135 15 150 15 180 30 180 45 195 45 210 60 225 105 225 135 210 150 210 165 195 195 180 210
Line -16777216 false 135 255 90 210
Line -16777216 false 165 225 120 195
Line -16777216 false 135 165 180 210
Line -16777216 false 150 150 201 186
Line -16777216 false 165 135 210 150
Line -16777216 false 165 120 225 120
Line -16777216 false 165 106 221 90
Line -16777216 false 157 91 210 60
Line -16777216 false 150 60 180 45
Line -16777216 false 120 30 96 26
Line -16777216 false 124 0 135 15

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

hawk
true
0
Polygon -7500403 true true 151 170 136 170 123 229 143 244 156 244 179 229 166 170
Polygon -16777216 true false 152 154 137 154 125 213 140 229 159 229 179 214 167 154
Polygon -7500403 true true 151 140 136 140 126 202 139 214 159 214 176 200 166 140
Polygon -16777216 true false 151 125 134 124 128 188 140 198 161 197 174 188 166 125
Polygon -7500403 true true 152 86 227 72 286 97 272 101 294 117 276 118 287 131 270 131 278 141 264 138 267 145 228 150 153 147
Polygon -7500403 true true 160 74 159 61 149 54 130 53 139 62 133 81 127 113 129 149 134 177 150 206 168 179 172 147 169 111
Circle -16777216 true false 144 55 7
Polygon -16777216 true false 129 53 135 58 139 54
Polygon -7500403 true true 148 86 73 72 14 97 28 101 6 117 24 118 13 131 30 131 22 141 36 138 33 145 72 150 147 147

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.0.5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
